- Main Page
- Modules
- Classes
- Files
- Directories
- Related Pages

# User interface: cEnvir and ev

## Classes
class | cEnvir
| Interface to the environment (user interface) of the simulation. More...
## Variables
ENVIR_API cEnvir | ev

## Variable Documentation

ENVIR_API cEnvir ev

| Represents the "environment" or user interface of the simulation. Most common usage from model code (simple modules) is to write log messages, e.g.:
     ev << "Received packet " << msg->name() << ", length " << msg->length()/8 << " bytes\n";
     ev << "Sending up to higher layer\n";
Other useful methods are cEnvir::isGUI() and cEnvir::disabled(). The rest of cEnvir methods are used internally for communication between the simulation kernel and the environment.